#!/bin/bash
#
# saf.ai version 1.0.1
#
# Copyright (C) 2020 saf.ai, Inc.
# Copyright (C) 2020 Ahmed Masud <ahmed.masud@saf.ai>
#


main() {

	init_vars
	
	dev=$1 mp=$2 opts=$3
	name=$(echo ${dev}| sed -e s,^/,, -e s,/,_,g)
	inner_mp=$MOUNTS/by-dev/${name}
	logfile=$logdir/$name.log
	errfile=$logdir/$name.err

	log "mounting $dev on $mp (via $inner_mp)"
	mkdir -p $inner_mp
	launcher=${datadir}/mount.cefs-$name.launch
cat > $launcher <<EOF
#!/bin/bash
# -*- autogenerated -*-
# do not modify

cd /
P=${launcher}
trap cleanup 0 1 2 3 15

set -e
cleanup() {
	umount -q $inner_mp
}

if $SAFAI_BIN storage bind $dev $inner_mp ; then
	CEFS_LOG='trace'
	$CEFS_BIN -o allow_other,default_permissions,fsname=saf.ai:${dev} $inner_mp $mp
fi
EOF
	chmod 0700 $launcher
	daemon -D / --noconfig --name=${name} -i -O ${logfile} -E ${errfile} -- $launcher
}


main "$@" || exit 1

